## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           systemc
Version:        3.0.0
Release:        %autorelease
Summary:        SystemC Reference Implementation 
License:        Apache-2.0 AND FSFUL AND FSFULLR AND GPL-2.0-only AND GPL-3.0-or-later AND HPND
URL:            https://systemc.org/overview/systemc
Source:         https://github.com/accellera-official/systemc/archive/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  cmake
BuildRequires:  ninja-build
BuildRequires:  gcc-c++

# Workaround for some versions of systemc
Patch:          0001-Add-DEVELOPMENT.md.patch

# Specific to building Fedora
Patch:          0002-Remove-RPATH.patch
Patch:          0003-Break-out-qt-copyright.h-to-COPYRIGHT.qt.patch
Patch:          0004-Properly-annotate-sc_main-as-a-weak-symbol.patch

%description
SystemC addresses the need for a system design and verification language 
that spans hardware and software. It is a language built as an ANSI C++ class 
library created for design and verification. Users worldwide are applying 
SystemC to system-level modeling, abstract analog/mixed-signal modeling,
architectural exploration, performance modeling, software development,
functional verification, and high-level synthesis. The SystemC API
and its semantics are developed by the Accellera Systems Initiative
and formally standardized and governed by the IEEE 
in the IEEE Std. 1666-2023 standard.

%package devel
Summary:        Development headers and libraries for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
This package contains the library and header files needed
for SystemC development.


%prep
%autosetup -p1

%build
%cmake  \
    -G Ninja    \
    -D BUILD_SHARED_LIBS=ON \
    -D ENABLE_EXAMPLES=OFF   \
    -D ENABLE_REGRESSION=OFF \
    -D CMAKE_BUILD_TYPE=None  \
    -D CMAKE_INSTALL_PREFIX=%{_prefix}  \
    -D CMAKE_CXX_STANDARD=17    \
    -D CMAKE_INSTALL_FULL_LIBDIR=%{_libdir} \
    -D ENABLE_PTHREADS=ON
%cmake_build

%install
# Remove extra debug file
rm -rf %{buildroot}%{_prefix}/lib/debug/%{_libdir}/libsystemc.so.*

%cmake_install
# Remove NOTICE and LICENSE so we can mark
# the copy in the source directory as "license"
rm %{buildroot}%{_datadir}/doc/systemc/LICENSE
rm %{buildroot}%{_datadir}/doc/systemc/NOTICE

# Move COPYRIGHT.qt to a more convenient spot
mv src/sysc/packages/qt/COPYRIGHT.qt COPYRIGHT.qt
mv src/sysc/packages/qt/INSTALL INSTALL.qt

%files
%license LICENSE NOTICE COPYRIGHT.qt INSTALL.qt
%{_libdir}/libsystemc.so.*

%files devel
%license LICENSE NOTICE COPYRIGHT.qt INSTALL.qt
%doc %{_datadir}/doc/systemc
%{_includedir}/sysc
%{_includedir}/systemc*
%{_includedir}/tlm*
%{_libdir}/cmake/SystemC*
%{_libdir}/libsystemc.so

%changelog
## START: Generated by rpmautospec
* Sat Apr 06 2024 John Doe <packager@example.com> - 3.0.0-1
- Uncommitted changes
## END: Generated by rpmautospec
